<template>
  <div>
    <b-navbar type="light" class="nav-horizontal py-1">
      <b-navbar-brand to="/dashboard">
        <img src="@/assets/logo.svg" alt="Citadel" height="50" />
      </b-navbar-brand>

      <!-- Right aligned nav items -->
      <b-navbar-nav class="ms-auto">
        <!-- Chain badge -->
        <b-badge
          v-if="bitcoinStore.chain !== 'main'"
          variant="success"
          class="align-self-center me-2 text-capitalize"
          pill
          >{{
            bitcoinStore.chain === "test" ? "testnet" : bitcoinStore.chain
          }}</b-badge
        >

        <div
          class="toggle-theme-icon d-flex align-items-center"
          @click="toggleTheme"
        >
          <div v-if="colorMode.value === 'light'" class="icon-24px">
            <MoonIcon />
          </div>
          <div v-if="colorMode.value === 'dark'" class="icon-24px">
            <SunIcon />
          </div>
        </div>

        <div
          class="nav-hamburger-icon d-lg-none d-xl-none ms-3"
          :class="{ active: uiStore.isMobileMenuOpen }"
          @click="toggleMobileMenu"
        >
          <div></div>
        </div>

        <b-nav-item-dropdown
          class="d-none d-lg-block d-xl-block ms-2"
          right
          no-caret
        >
          <!-- Using 'button-content' slot -->
          <template #button-content>{{
            userStore.name.split(" ")[0]
          }}</template>
          <b-dropdown-item @click="logout">Log out</b-dropdown-item>
        </b-nav-item-dropdown>
      </b-navbar-nav>
    </b-navbar>

    <!-- Mobile menu -->
    <transition name="mobile-vertical-menu">
      <div
        v-if="uiStore.isMobileMenuOpen"
        class="mobile-vertical-menu d-lg-none d-xl-none"
      >
        <authenticated-vertical-navbar :is-mobile-menu="true" />
      </div>
    </transition>

    <transition name="mobile-vertical-menu-fader">
      <div
        v-if="uiStore.isMobileMenuOpen"
        class="mobile-vertical-menu-fader d-lg-none d-xl-none"
        @click="toggleMobileMenu"
      ></div>
    </transition>

    <b-row class="mx-0">
      <b-col
        col
        lg="3"
        xl="2"
        class="d-none d-lg-block d-xl-block ps-0 pe-0 pe-xl-2"
      >
        <authenticated-vertical-navbar />
      </b-col>

      <b-col col lg="9" xl="10">
        <div class="pe-xl-2 content-container">
          <slot />
        </div>

        <!-- Footer -->
        <footer class="d-flex justify-content-end text-muted pe-sm-2 pe-xl-3">
          <p>
            <small> Built by Nirvati. </small>
          </p>
        </footer>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts" setup>
import {
  SunIcon,
  MoonIcon,
} from "@bitcoin-design/bitcoin-icons-vue/filled/esm/index.js";
import useSystemStore from "../store/system";
import useUserStore from "../store/user";
import useUiStore from "../store/ui";
import useBitcoinStore from "../store/bitcoin";
import useLightningStore from "../store/lightning";

const systemStore = useSystemStore();
const userStore = useUserStore();
const uiStore = useUiStore();
const bitcoinStore = useBitcoinStore();
const lightningStore = useLightningStore();
const colorMode = useColorMode();

const dataFetchInterval = ref<number | undefined>(undefined);
const slowerDataFetchInterval = ref<number | undefined>(undefined);

onMounted(() => {
  // load this data once:
  userStore.getInfo();
  // Preload this so when the user switches to th Lightning page, it can be displayed immediately
  lightningStore.getVersionInfo();

  // refresh this data every 20s:
  fetchData();
  dataFetchInterval.value = window.setInterval(fetchData, 20000);
  // This data is't changing as much and fetching it every 5 minutes is enough
  fetchLessChangingData();
  slowerDataFetchInterval.value = window.setInterval(
    fetchLessChangingData,
    60 * 5 * 1000,
  );
});
onBeforeUnmount(() => {
  window.clearInterval(dataFetchInterval.value);
  window.clearInterval(slowerDataFetchInterval.value);
});

function toggleTheme() {
  colorMode.value = colorMode.value === "light" ? "dark" : "light";
}
function logout() {
  // close mobile menu
  if (uiStore.isMobileMenuOpen) {
    toggleMobileMenu();
  }
  userStore.logout();
}
function fetchData() {
  systemStore.getUnit();
  bitcoinStore.getSync();
  bitcoinStore.getBalance();
  bitcoinStore.getTransactions();
  lightningStore.getSync();
  lightningStore.getTransactions();
}
function fetchLessChangingData() {
  lightningStore.getChannels();
  bitcoinStore.getPrice();
}
function toggleMobileMenu() {
  uiStore.isMobileMenuOpen = !uiStore.isMobileMenuOpen;
}
</script>

<style lang="scss" scoped>
body[data-bs-theme="dark"] {
  .nav-horizontal {
    background: #2a3244 !important;
  }
  .mobile-vertical-menu {
    background: #2a3244 !important;
    box-shadow: 0px 10px 30px rgba(0, 0, 0, 0.4);
  }
}

.nav-horizontal {
  background: #fff;
  position: sticky;
  z-index: 9;
}

.nav-horizontal {
  top: 0;
}

.content-container {
  min-height: calc(100vh - 150px);
}

/*
.input-search-form {
  form {
    position: relative;
  }
  .input-search {
    border: none !important;
    outline: none !important;
    box-shadow: none !important;
    width: calc(100vw - 200px);
    max-width: 600px;
    font-size: 1rem;
    margin-left: 1rem;
  }
  .input-search-icon {
    content: url("~@/assets/icon-search.svg");
    position: absolute;
    top: calc(50% - 0.625rem);
    left: -0.25rem;
    height: 1.25rem;
    width: auto;
  }
}*/

::placeholder {
  color: #c3c6d1;
}

.toggle-theme-icon {
  cursor: pointer;
}

.nav-hamburger-icon {
  width: 24px;
  cursor: pointer;
  &:before,
  &:after,
  div {
    background-color: #c3c6d1;
    border-radius: 3px;
    content: "";
    display: block;
    height: 4px;
    width: 100%;
    margin: 5px 0;
    transition: transform 0.6s cubic-bezier(0.175, 0.885, 0.32, 1.275);
  }
  div {
    width: 20px;
    margin-left: 4px;
  }
  &.active {
    &:before {
      transform: translateY(9px) rotate(135deg);
    }
    &:after {
      transform: translateY(-9px) rotate(-135deg);
    }
    div {
      transform: scale(0);
    }
  }
}

.mobile-vertical-menu {
  position: fixed;
  z-index: 9;
  top: 84px;
  right: 0;
  width: 80vw;
  max-width: 280px;
  height: calc(var(--vh100, 100vh) - 84px);
  background: #fff;
  box-shadow: var(--card-shadow);
  transition: transform 0.6s cubic-bezier(0.77, 0, 0.175, 1);
}

.mobile-vertical-menu-enter-from {
  // opacity: 0;
  transform: translate3d(100%, 0, 0);
}
.mobile-vertical-menu-enter-to {
  opacity: 1;
  transform: translate3d(0, 0, 0);
}
.mobile-vertical-menu-leave {
  opacity: 1;
  transform: translate3d(0, 0, 0);
}
.mobile-vertical-menu-leave-to {
  // opacity: 0;
  transform: translate3d(100%, 0, 0);
}

.mobile-vertical-menu-fader {
  position: fixed;
  height: var(--vh100, 100vh);
  width: 100vw;
  left: 0;
  top: 0;
  background: rgba(0, 0, 0, 1);
  z-index: 8;
  opacity: 0.1;
  transition: opacity 0.6s ease-in-out;
}

.mobile-vertical-menu-fader-enter-from {
  opacity: 0;
}
.mobile-vertical-menu-fader-enter-to {
  opacity: 0.1;
}
.mobile-vertical-menu-fader-leave {
  opacity: 0.1;
}
.mobile-vertical-menu-fader-leave-to {
  opacity: 0;
}
</style>
